#ifndef _IMAGE_
#define _IMAGE_
#include "Share.h"

class THIImage:public TDebug
{
     private:    
      HWND bn;
      HBITMAP hBitmap;
   public:
    string _prop_BitmapName;
    int  _prop_Left;
    int _prop_Top;
    int  _prop_Width;
    int _prop_Height;
    int _prop_Color;
    int _prop_X;
    int _prop_Y;
    int _prop_X2;
    int _prop_Y2;
    bool _prop_AddLayer;
    int Left,Top,Width,Height;
    THI_Event *_data_Handle;
    THI_Event *_data_BitmapName;
    THI_Event *_data_Left;
    THI_Event *_data_Top;
    THI_Event *_data_Width;
    THI_Event *_data_Height;
    THI_Event *_data_X;
    THI_Event *_data_Y;
    THI_Event *_data_X2;
    THI_Event *_data_Y2; 
    THI_Event *_event_onDraw;
    THI_Event *_event_onMemoryClear; 
    
    
    HI_WORK_LOC(THIImage,_work_doImage)
      {        TData dt;
               dt.data_type = data_null; 	      
          string gtur= ReadString(_Data,_data_BitmapName,_prop_BitmapName);
           Left = ReadInteger(dt,_data_Left,_prop_Left);
           Top = ReadInteger(dt,_data_Top,_prop_Top);
           Width = ReadInteger(dt,_data_Width,_prop_Width);
           Height = ReadInteger(dt,_data_Height,_prop_Height);
           int x = ReadInteger(dt,_data_X,_prop_X);
           int y = ReadInteger(dt,_data_Y,_prop_Y);
           int x2 = ReadInteger(dt,_data_X2,_prop_X2);
           int y2 = ReadInteger(dt,_data_Y2,_prop_Y2);
		   InvalidateRect(bn,NULL,false);         
         bn=(HWND) ReadInteger(_Data,_data_Handle,0);
           PAINTSTRUCT ps;
          HDC hdc=BeginPaint(bn, &ps);
            if(hBitmap==NULL)
          hBitmap= SHLoadDIBitmap (PChar(gtur));
         HDC hdcMemory = CreateCompatibleDC(hdc);
          SelectObject(hdcMemory,hBitmap);
    bool sr=StretchBlt(hdc,Left,Top,Width,Height,hdcMemory,x,y,x2,y2,SRCCOPY);
    	     if (sr==false)
       MessageBox(NULL,L"Cannot paint image!",L"Error",MB_OK);
               if(_prop_AddLayer)
           InvalidateRect(bn,NULL,false);	           
        EndPaint(bn, &ps);
        SelectObject(hdcMemory,hBitmap);
             DeleteDC(hdcMemory);
             DeleteDC(hdc);
         _hi_onEvent(_event_onDraw);      
      }                
                           
    HI_WORK_LOC(THIImage,_work_doClear)
    {  
        RECT r;
        r.left = Left;
        r.top = Top;
        r.right = Left+Width;
        r.bottom = Top+Height;
     PAINTSTRUCT ps;
     HDC hdc=BeginPaint(bn, &ps);
    RedrawWindow(bn,&r,NULL,RDW_INVALIDATE|RDW_UPDATENOW|RDW_ERASE|RDW_ERASENOW|RDW_ALLCHILDREN);
       EndPaint(bn, &ps); 
       DeleteDC(hdc);              
     }
     
    HI_WORK_LOC(THIImage,_work_doMemoryClear) 
	{
	   hBitmap=NULL;
	   _hi_onEvent(_event_onMemoryClear);
        } 
	         
};
#endif
////////////////////////////////////////////////////////////////////////
 
